<?php
require_once(WCF_DIR.'lib/acp/package/plugin/AbstractPackageInstallationPlugin.class.php');
require_once(WCF_DIR.'lib/acp/package/TemplatesFileHandler.class.php');

/**
 * @author M. Schwendowius
 * @url http://community.woltlab.com
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 * @package	com.woltlab.community.customPage
 */
class CustomPagePackageInstallationPlugin extends AbstractPackageInstallationPlugin {
	public $tagName = 'wrappertemplates';
	public $tableName = 'custompage_wrapper';
	
	/**
	 * Installs the templates of this package.
	 */
	public function install() {
		parent::install();

		//extracts the *.tar and adds the given wrapper tpls to "wcf/templates" folder
		$tag = $this->installation->getXMLTag('wrappertemplates');
		$sourceFile = $this->installation->getArchive()->extractTar($tag['cdata'], 'wrappertemplates_');

		//creates file handler
		$fileHandler = new TemplatesFileHandler($this->installation);

		//untars the *.tar file
		$packageDir = FileUtil::addTrailingSlash(FileUtil::getRealPath(WCF_DIR.$this->installation->getPackage()->getDir()));
		$fileInstaller = $this->installation->extractFiles(WCF_DIR.'templates/', $sourceFile, $fileHandler);

		//creates the database entries for the customPageWrapper table
		$tar = new Tar($sourceFile);
		$packageID = $this->installation->getPackageID();
		$files = $tar->getContentList();
		foreach ($files as $file) {
			$templateNames = array();
			$templateNames[] = "'".substr($file['filename'], 0, -4)."'";
			foreach ($templateNames as $templateName) {
				$sql =  "SELECT *
					FROM wcf".WCF_N."_custompage_wrapper
					WHERE templateName LIKE ".$templateName;
				$result = WCF::getDB()->sendQuery($sql);
				while ($row = WCF::getDB()->fetchArray($result)) {
					$tempResult[] = $row;
				}
				if (!empty($tempResult)) continue;

				$sql = "INSERT INTO `wcf".WCF_N."_custompage_wrapper`
					(wrapperID,packageID,templateName)
					VALUES
					(NULL,
					".$packageID.",
					".$templateName.")";
				WCF::getDB()->sendQuery($sql);
			}
		}
		//deletes the source file from temp dir
		@unlink($sourceFile);
	}
	
	/**
	 * Uninstalls the Wrappers and deletes the database entries
	 */

	public function uninstall() {
		//deletes the tpl files
		$templates = array();

		$sql = "SELECT	*
			FROM	wcf".WCF_N."_custompage_wrapper
			WHERE 	packageID = ".$this->installation->getPackageID();
		$result = WCF::getDB()->sendQuery($sql);
		while ($row = WCF::getDB()->fetchArray($result)) {
			$files[] = 'templates/'.$row['templateName'].'.tpl';
		}
		
		if (count($files) > 0) {

			$packageDir = FileUtil::addTrailingSlash(FileUtil::getRealPath(WCF_DIR.$this->installation->getPackage()->getDir()));
			$deleteEmptyDirectories = $this->installation->getPackage()->isStandalone();
			$this->installation->deleteFiles($packageDir, $files, false, $deleteEmptyDirectories);

			parent::uninstall();
		}
		//deletes the database entries of the selected wrapper installation
		$sql = "DELETE 
			FROM wcf".WCF_N."_custompage_wrapper
			WHERE packageID = ".$this->installation->getPackageID();
		WCF::getDB()->sendQuery($sql);
	}
	
}
?>
