<?php
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');

class CustomPageDeleteAction extends AbstractAction {
	public $pageID = 0;
	
	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();
		if (isset($_REQUEST['pageID'])) $this->pageID = intval($_REQUEST['pageID']);
	}
	
	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();
		// check permission
		WCFACP::checkMasterPassword();
		WCF::getUser()->checkPermission('admin.system.custompages.canDelete');
		require_once(WCF_DIR.'lib/data/custompage/CustomPageEditor.class.php');
		// deletes CustomPage  "by ID" and resets cache
		CustomPageEditor::deleteCustomPage($this->pageID);
		$this->executed();
		// forward to list page
		header('Location: index.php?page=CustomPageList&deletedPage=1&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
		exit;
	}
}
?>