<?php
// wcf imports
require_once(WCF_DIR.'lib/acp/form/CustomPageAddForm.class.php');
require_once(WCF_DIR.'lib/data/custompage/CustomPageEditor.class.php');

/**
 * Shows the CustomPage edit form.
 * 
 * @author	 Martin Schwendowius, Oliver Kliebisch
 * @copyright	2008-2009 plugins.wbuilder.de
 * @license	Creative Commons <hhttp://creativecommons.org/licenses/by-nc-nd/3.0/deed.de>
 * @package	com.woltlab.community.customPage
 */
class CustomPageEditForm extends CustomPageAddForm {
	public $activeMenuItem = 'wcf.acp.menu.link.content.custompage';
	public $pageID = 0;
	public $pages = array();
	
	/**
	 * @see Form::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();
		
		if(isset($_REQUEST['pageID']))	$this->pageID = intval($_REQUEST['pageID']);
		WCF::getCache()->addResource('custompages',
		WCF_DIR.'cache/cache.custompages.php',
		WCF_DIR.'lib/system/cache/CacheBuilderCustomPages.class.php');
	}

	/**
	 * @see Page::readData()
	 */
	public function readData() {
		parent::readData();
		
		$page = WCF::getCache()->get('custompages', $this->pageID);
		$this->name                        = $page->name;
		$this->description                = $page->description;
		$this->icon                        = $page->icon;
		$this->wrapperID                = $page->wrapperID;
		$this->content                        = $page->content;
		$this->parentPageID        = $page->parentPageID;
		$this->preParentID        = $page->preParentID;
                WCF::getCache()->clearResource('custompages');
	}

	/**
	 * @see Page::assignVariables()
	 */
	public function assignVariables() {
		parent::assignVariables();
		
		WCF::getTPL()->assign(array(
			'pageID' => $this->pageID,
			'action' => 'edit'
		));
		//sets active menuItem
		WCFACP::getMenu()->setActiveMenuItem($this->activeMenuItem);
	}

	/**
	 * @see Form::save()
	 */
	public function save() {
		$page = new CustomPageEditor($this->pageID);
		$page->update($this->name, $this->description, $this->icon, $this->wrapperID, $this->content, $this->parentPageID, $this->preParentID);
		$this->saved();
		//redirect to list page after save
		header('Location: index.php?page=CustomPageList&editPage=1&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
		exit;
	}
	
	/**
	 * @see Page::show()
	 */
	public function show() {
		WCFACP::checkMasterPassword();
		
		parent::show();
	}
	
}
?>
