<?php
error_reporting(E_ERROR | E_WARNING | E_PARSE | E_COMPILE_ERROR);

// wcf imports
require_once(WCF_DIR.'lib/page/AbstractPage.class.php');
require_once(WCF_DIR.'lib/data/custompage/CustomPageEditor.class.php');

/**
 * Shows the selected CustomPage.
 * 
 * @author	 Martin Schwendowius, Oliver Kliebisch
 * @copyright	2008-2009 plugins.wbuilder.de
 * @license	Creative Commons <hhttp://creativecommons.org/licenses/by-nc-nd/3.0/deed.de>
 * @package	com.woltlab.community.custompages
 */
class CustomPage extends AbstractPage {
	public $pageID = 0;
	public $childPages;
	public $page;	
	public $templateName;
	

	/**
	 * @see Page::readParameters()
	 */	
	public function readParameters() {
		parent::readParameters();
		
		if(isset($_REQUEST['pageID'])) {
			$this->pageID = $_REQUEST['pageID'];
		}
		else {
			throw new IllegalLinkException();
		}
	}

	/**
	 * @see Page::readData()
	 */	
	public function readData() {
		parent::readData();		
		try {
			$this->page = CustomPageEditor::getPageByID($this->pageID);
		}
		catch(SystemException $ex) {
			throw new IllegalLinkException();
		}
		WCF::getUser()->checkPermission($this->page->permission);
		$this->childPages = CustomPageEditor::getChildPages($this->pageID);
		$sql="SELECT templateName FROM wcf".WCF_N."_custompage_wrapper WHERE wrapperID=".$this->page->wrapperID;
		$result = WCF::getDB()->getFirstRow($sql);
		$this->templateName = $result['templateName'];
	}

	/**
	 * @see Page::assignVariables()
	 */
	public function assignVariables() {
		parent::assignVariables();
		WCF::getTPL()->assign(array('title' => $this->page->name,
									'description' => $this->page->description,
									'icon' => $this->page->icon,
									'parentPageID' => $this->page->parentPageID,
									'breadCrumbs' => null,
									'templateName' => $this->page->templateName,
									'children' => $this->childPages,
									'pageID' => $this->pageID,
									'allowSpidersToIndexThisPage' => true));
	}
	
	/**
	 * @see Page::show()
	 */
	public function show() {
		// mark Page as active
		require_once(WCF_DIR.'lib/page/util/menu/PageMenu.class.php');
		PageMenu::setActiveMenuItem('wcf.acp.group.option.category.custompages.'.$this->pageID);
		parent::show();
	}	
}

?>